       ; HDEMULV2/ASM - Z80 Illegal Instruction Emulator
 ;		LNW Team - NewDos/80
 ;	This program is designed to emulate the illegal
 ;	 Z80 instructions for the HD64180ROP Processor
 ;
 ; Assemble to HDEMUL/CIM Then load it.
 ;  Dump HDROM/CIM 0,3600H,0,8000H
 ; Then Zap the first Jump in the Rom to C3 00 35
 ;
 ; Use SYSINT/CMD to Load it
 ;*******************************************************
 ; UPDATED 03/10/86
 ;
 ;*****************************************************
 	ORG	3500H	; SAVE ADDRESS
 ;
 ; Enter With Interupts already disabled
 START  	PUSH	HL	; SAVE REGS
 	PUSH	DE
 	PUSH	IY
 	PUSH	IX
 	PUSH	BC
 	PUSH	AF	; ALL REGS SAVED
 ; Ok Lets get PC value on the stack before the pushes
 	LD	HL,12	; # Of bytes from the PUSHES
 	ADD	HL,SP	; HL=Current stack Position
 	LD	E,(HL)
 	INC	HL
 	LD	D,(HL)
 	EX	DE,HL	; HL=Address of OPCODE
 ;*******************************************************
 ;		Check for Z80 System
 SYS  	DEFB	0EDH,38H,18H ; HD64180 INO (18H),A
 	DEFB	3H	     ; IF HD64180 THEN INC BC
 	JP	HD64	; HD64180 SYSTEM
 ;
 Z80	LD	HL,DATA	; WILL END UP HERE IF Z80
 	LD	DE,7000H	; PLACE TO PUT IT
 	LD	BC,LEN
 	LDIR	; Move code to safe place and then run it
 	JP	7000H
 ;********************************************************
 ; Now check if TRAP flag is set
 HD64	DEFB	0EDH	; OPCODE for IN0 g,(m)
 	DEFB	38H	; A Reg
 	DEFB	34H	; Port 34H to A reg
 	BIT	7,A	; Check for TRAP bit ?
 	JP	Z,BOOT	; Oh Must be a boot.. Go do it
 	BIT	6,A	; Check UFO Flag
 	JR	Z,EMU1	; PC-1
 ; Ok must be PC-2 so Adjust address
 	DEC	HL
 EMU1	DEC	HL	; HL= Start of OPCODE
 ; Now compare first Byte for Type of OPcode
 	LD	A,(HL)
 	CP	0CBH	; ?
 	JR	Z,SLS	; is a SLS x OPCODE
 	CP	0DDH	; ?
 	JR	Z,LDALX	; Is a LD  A,LX OPCODE
  ; Oh... We haven't Emulated it Yet... Declare an ERROR
 BAD	LD	HL,12
 	ADD	HL,SP	; RESET SP
 	LD	SP,HL
 	JP	440DH	; DEBUG
 SLS	INC	HL
 	LD	A,(HL)
 	CP	31H	; ? SLS C
 	JR	Z,SLSC
 	CP	37H	; ? SLS A
 	JR	Z,SLSA
 	JR	BAD	; CANT DO IT
 ;********************************************************
 ;	SLS A - Rotate Left and add 1
 SLSA	POP	AF	; GET AF
 ;
 	RLA		; SLS A Code
 	SET	0,A	; Inc 1
 ;
 	PUSH	AF
 	JR	DONE	; DONE
 ;********************************************************
 ;	SLS C - Rotate Left and add 1
 SLSC	POP	AF
 	POP	BC
 ;
 	RLC	C	; SLS C Code
 	SET	0,C
 	PUSH	BC
 	PUSH	AF
 	JR	DONE
 ;********************************************************
 ;	LD A,LX - Load A with X register
 LDALX	POP	AF
 	POP	BC
 	POP	HL	; IS REALLY IX
 ;
 	LD	A,L
 	PUSH	HL	; REALLY IX
 	PUSH	BC
 	PUSH	AF
 	JR	DONE	; DONE
 ;
 ;********************************************************
 ;	DONE - Now Adjust PC Address
 ;		DE Still has OPCODE Address + 1
 ;
 DONE	EX	DE,HL	; GET ADDRESS
 	LD	D,(HL)	; MSB
 	DEC	HL
 	LD	E,(HL)	; LSB
 	INC	DE	; BUMP1
 	LD	(HL),E	; PUT BACK
 	INC	HL
 	LD	(HL),D
 ; Get Port 34H Trap port
 	DEFB	0EDH	; OPCODE  IN (m),g
 	DEFB	38H
 	DEFB	34H	; TRAP PORT
 ; Now Clear Trap Bit
 	RES	7,A
 	DEFB	0EDH	; OPCODE OUT (m),g
 	DEFB	39H
 	DEFB	34H	; TRAP PORT
 ;
 	POP	AF
 	POP	BC
 	POP	IX
 	POP	IY
 	POP	DE
 	POP	HL
 ; Now return to Corrected address
 	EI
 	RET
 ;
 BOOT	XOR	A
 	JP	0674H	; GO BOOT
 ;
 ;*******************************************************
 ;	This Code Switches back to ROM then Boots the 
 ;	  Z80 SYSTEM
 ;
 DATA	LD	A,0
 	DI
 	OUT	(1FH),A	; RESET MAP
 	; RESET TO SD ON FDC
 	LD	A,0FEH
 	LD	(37ECH),A   ; DOUBLE TO SINGLE DENSITY
 	JP	0H
 DAT1	NOP
 LEN	EQU	DAT1-DATA
 ;
 	END	START
